import * as lib_postgres from '@powersync/lib-service-postgres';
import { storage } from '@powersync/service-core';
/**
 * Additional options, primarily for testing.
 */
export interface PostgresCompactOptions extends storage.CompactOptions {
    /** Minimum of 2 */
    clearBatchLimit?: number;
    /** Minimum of 1 */
    moveBatchLimit?: number;
    /** Minimum of 1 */
    moveBatchQueryLimit?: number;
}
export declare class PostgresCompactor {
    private db;
    private group_id;
    private updates;
    private idLimitBytes;
    private moveBatchLimit;
    private moveBatchQueryLimit;
    private clearBatchLimit;
    private maxOpId;
    private buckets;
    constructor(db: lib_postgres.DatabaseClient, group_id: number, options?: PostgresCompactOptions);
    /**
     * Compact buckets by converting operations into MOVE and/or CLEAR operations.
     *
     * See /docs/compacting-operations.md for details.
     */
    compact(): Promise<void>;
    compactInternal(bucket: string | undefined): Promise<void>;
    private flush;
    /**
     * Perform a CLEAR compact for a bucket.
     *
     * @param bucket bucket name
     * @param op op_id of the last non-PUT operation, which will be converted to CLEAR.
     */
    private clearBucket;
}
