import { TestStorageOptions } from '@powersync/service-core';
import { PostgresMigrationAgent } from '../migrations/PostgresMigrationAgent.js';
import { PostgresStorageConfigDecoded } from '../types/types.js';
import { PostgresBucketStorageFactory } from './PostgresBucketStorageFactory.js';
export type PostgresTestStorageOptions = {
    url: string;
    /**
     * Vitest can cause issues when loading .ts files for migrations.
     * This allows for providing a custom PostgresMigrationAgent.
     */
    migrationAgent?: (config: PostgresStorageConfigDecoded) => PostgresMigrationAgent;
};
export declare const PostgresTestStorageFactoryGenerator: (factoryOptions: PostgresTestStorageOptions) => (options?: TestStorageOptions) => Promise<PostgresBucketStorageFactory>;
