/**
 * TODO share this implementation better in the core package.
 * There are some subtle differences in this implementation.
 */
import { storage } from '@powersync/service-core';
import { RequiredOperationBatchLimits } from '../../types/types.js';
/**
 * Batch of input operations.
 *
 * We accumulate operations up to MAX_RECORD_BATCH_SIZE,
 * then further split into sub-batches if MAX_CURRENT_DATA_BATCH_SIZE is exceeded.
 */
export declare class OperationBatch {
    protected options: RequiredOperationBatchLimits;
    batch: RecordOperation[];
    currentSize: number;
    readonly maxBatchCount: number;
    readonly maxRecordSize: number;
    readonly maxCurrentDataBatchSize: number;
    get length(): number;
    constructor(options: RequiredOperationBatchLimits);
    push(op: RecordOperation): void;
    shouldFlush(): boolean;
    /**
     *
     * @param sizes Map of source key to estimated size of the current_data document, or undefined if current_data is not persisted.
     *
     */
    batched(sizes: Map<string, number> | undefined): Generator<RecordOperation[]>;
}
export declare class RecordOperation {
    readonly record: storage.SaveOptions;
    readonly afterId: storage.ReplicaId | null;
    readonly beforeId: storage.ReplicaId;
    readonly internalBeforeKey: string;
    readonly internalAfterKey: string | null;
    readonly estimatedSize: number;
    constructor(record: storage.SaveOptions);
}
/**
 * In-memory cache key - must not be persisted.
 */
export declare function cacheKey(sourceTableId: string, id: storage.ReplicaId): string;
/**
 * Calculates a cache key for a stored ReplicaId. This is usually stored as a bytea/Buffer.
 */
export declare function encodedCacheKey(sourceTableId: string, storedKey: Buffer): string;
