import * as lib_postgres from '@powersync/lib-service-postgres';
import { storage } from '@powersync/service-core';
export type PostgresCheckpointAPIOptions = {
    db: lib_postgres.DatabaseClient;
    mode: storage.WriteCheckpointMode;
};
export declare class PostgresWriteCheckpointAPI implements storage.WriteCheckpointAPI {
    readonly db: lib_postgres.DatabaseClient;
    private _mode;
    constructor(options: PostgresCheckpointAPIOptions);
    get writeCheckpointMode(): storage.WriteCheckpointMode;
    setWriteCheckpointMode(mode: storage.WriteCheckpointMode): void;
    batchCreateCustomWriteCheckpoints(checkpoints: storage.CustomWriteCheckpointOptions[]): Promise<void>;
    createCustomWriteCheckpoint(options: storage.CustomWriteCheckpointOptions): Promise<bigint>;
    createManagedWriteCheckpoint(checkpoint: storage.ManagedWriteCheckpointOptions): Promise<bigint>;
    lastWriteCheckpoint(filters: storage.LastWriteCheckpointFilters): Promise<bigint | null>;
    protected lastCustomWriteCheckpoint(filters: storage.CustomWriteCheckpointFilters): Promise<bigint | null>;
    protected lastManagedWriteCheckpoint(filters: storage.ManagedWriteCheckpointFilters): Promise<bigint | null>;
}
export declare function batchCreateCustomWriteCheckpoints(db: lib_postgres.DatabaseClient, checkpoints: storage.CustomWriteCheckpointOptions[]): Promise<void>;
