import * as t from 'ts-codec';
export declare enum OpType {
    PUT = "PUT",
    REMOVE = "REMOVE",
    MOVE = "MOVE",
    CLEAR = "CLEAR"
}
export declare const BucketData: t.ObjectCodec<{
    group_id: t.Codec<number, number, "pg_number", t.CodecProps>;
    bucket_name: t.IdentityCodec<t.CodecType.String>;
    op_id: t.Codec<bigint, string | number, string, t.CodecProps>;
    op: t.EnumCodec<typeof OpType>;
    source_table: t.Union<t.Codec<null, null, string, t.CodecProps>, t.IdentityCodec<t.CodecType.String>>;
    source_key: t.Union<t.Codec<null, null, string, t.CodecProps>, t.Codec<Buffer, string, "hexBuffer", t.CodecProps>>;
    table_name: t.Union<t.Codec<string, string, string, t.CodecProps>, t.Codec<null, null, t.CodecType.Null, t.CodecProps>>;
    row_id: t.Union<t.Codec<string, string, string, t.CodecProps>, t.Codec<null, null, t.CodecType.Null, t.CodecProps>>;
    checksum: t.Codec<bigint, string | number, string, t.CodecProps>;
    data: t.Union<t.Codec<null, null, string, t.CodecProps>, t.IdentityCodec<t.CodecType.String>>;
    target_op: t.Union<t.Codec<null, null, string, t.CodecProps>, t.Codec<bigint, string | number, string, t.CodecProps>>;
}>;
export type BucketData = t.Encoded<typeof BucketData>;
export type BucketDataDecoded = t.Decoded<typeof BucketData>;
