import * as t from 'ts-codec';
export type StoredRelationId = {
    object_id: string | number;
};
export declare const ColumnDescriptor: t.ObjectCodec<{
    name: t.IdentityCodec<t.CodecType.String>;
    /**
     *  The type of the column ie VARCHAR, INT, etc
     */
    type: t.OptionalCodec<t.Codec<string, string, string, t.CodecProps>>;
    /**
     *  Some data sources have a type id that can be used to identify the type of the column
     */
    typeId: t.OptionalCodec<t.Codec<number, number, string, t.CodecProps>>;
}>;
export declare const SourceTable: t.ObjectCodec<{
    id: t.IdentityCodec<t.CodecType.String>;
    group_id: t.Codec<number, number, "pg_number", t.CodecProps>;
    connection_id: t.Codec<bigint, string | number, string, t.CodecProps>;
    relation_id: t.Union<t.Codec<null, null, string, t.CodecProps>, t.Codec<StoredRelationId, string, string, t.CodecProps>>;
    schema_name: t.IdentityCodec<t.CodecType.String>;
    table_name: t.IdentityCodec<t.CodecType.String>;
    replica_id_columns: t.Union<t.Codec<null, null, string, t.CodecProps>, t.Codec<{
        name: string;
        type?: string | undefined;
        typeId?: number | undefined;
    }[], string, string, t.CodecProps>>;
    snapshot_done: t.IdentityCodec<t.CodecType.Boolean>;
}>;
export type SourceTable = t.Encoded<typeof SourceTable>;
export type SourceTableDecoded = t.Decoded<typeof SourceTable>;
