import * as t from 'ts-codec';
/**
 * Returns a new codec with a subset of keys. Equivalent to the TypeScript Pick utility.
 */
export const pick = (codec, keys) => {
    // Filter the shape by the specified keys
    const newShape = Object.fromEntries(Object.entries(codec.props.shape).filter(([key]) => keys.includes(key)));
    // Return a new codec with the narrowed shape
    return t.object(newShape);
};
//# sourceMappingURL=ts-codec.js.map